//#include "F:\net download\net 2013\09_13\display\vm\self try\main_16F876A_vm.h"

#include <16F876A.h>
 
//ADC resolution
#device ADC=10
//CONFIG words
#FUSES NOWDT                    //No Watch Dog Timer
#FUSES NOBROWNOUT               //No brownout reset
#FUSES NOLVP                    //No low voltage prgming, B3(PIC16) or B5(PIC18) used for I/O
#FUSES HS 
 
//Clock used for delay routines
#use delay(crystal=12MHz)
 
#use FIXED_IO(B_outputs=PIN_B7,PIN_B6,PIN_B5,PIN_B4,PIN_B3,PIN_B2,PIN_B1,PIN_B0)
#use FIXED_IO(C_outputs=PIN_C7,PIN_C6,PIN_C5,PIN_C4,PIN_C3,PIN_C2,PIN_C1,PIN_C0)
 
//Global Variables
unsigned int8 enablessdx = 0;
unsigned char display[3], SSDVAL1 = 0, SSDVAL2 = 0, SSDVAL3 = 0;
unsigned long dummy = 0;
//Function Definitions
 
void turnoffssd(){
      output_low(PIN_b0);   
      output_low(PIN_b1);
      output_low(PIN_b2);   
}
 
void splitnum(){
      display[0] = (dummy % 10);
      display[1] = (dummy / 10) % 10;
      display[2] = (dummy / 100);
}
 
//******************* ISR Code starts ******************************************************
//Comment this code if you don't want to use interrupts to display SSD data.
//If this code is commented out then the code in while(1) loop which displays
//SSD data should be uncommented.
#INT_TIMER1
void TIMER1_isr(void)
{    
   if(interrupt_active(int_timer1)) 
   {
         enablessdx++;
         if(enablessdx == 4)enablessdx = 1;
         turnoffssd();
         switch(enablessdx){
               case 1:
                     output_c(SSDVAL3);
                     output_high(PIN_b0);
                     break;
               case 2:
                     output_c(SSDVAL2);
                     output_high(PIN_b1);         
                     break;
               case 3:
                     output_c(SSDVAL1);
                     output_high(PIN_b2);         
                     break;   
         }   
   }
   
   set_timer1(0xFDA7);
   clear_interrupt(int_timer1);
}
 
//******************* ISR Code ends ******************************************************
 
void main()
{
   unsigned char CA[] = {0xC0, 0xF9, 0xA4, 0xB0, 0x99, 0x92, 0x82, 0xF8, 0x80, 0x90};
      //     0   1      2     3     4     5      6    7     8     9   

   unsigned char CA_P_o[] = {0xC8, 0xA3};
         //   P     o   
   unsigned char CA_P_1[] = {0xC8, 0xEF};
           // P     1

   
   float value;
      
   set_tris_b(0x00);
   set_tris_c(0x00);
   
   output_b(0x00); 
   output_c(0x00);
   
   setup_comparator(NC_NC_NC_NC);
   
   setup_adc_ports(ALL_ANALOG); 
  // setup_adc_ports(sAN0 | sAN1);
   setup_adc(ADC_CLOCK_INTERNAL); 

   setup_vref(FALSE);
   
   setup_timer_1(T1_INTERNAL|T1_DIV_BY_1);
   set_timer1(0xFDA7);
   
   enable_interrupts(INT_TIMER1);
   enable_interrupts(GLOBAL);   
     
   while(TRUE)
   {
      //TODO: User Code
             splitnum();
                 SSDVAL1 = CA_P_o[display[0]];
                 SSDVAL2 = CA_P_o[display[1]];
                 SSDVAL3 = CA_P_o[display[2]];
           delay_ms(2000);

   set_adc_channel(0); 
      delay_us(100);  
      read_adc(ADC_START_only); 
      delay_us(100);          
      value = read_adc(ADC_read_only) * 30.0 / 1023.0;
            
      if((value >= 0.0) && (value < 10.0)){
                 dummy = (long)(value * 100.0);                  //1.23 becomes 123
                 splitnum();
                 SSDVAL1 = CA[display[0]];
                 SSDVAL2 = CA[display[1]];
                 SSDVAL3 = CA[display[2]]  & 0x7F;                 
      }
      else if((value >= 10.0) && (value < 100.0)){
                 dummy = (long)(value * 10.0);                   //12.3 becomes 123
                 splitnum();
                 SSDVAL1 = CA[display[0]];
                 SSDVAL2 = CA[display[1]] & 0x7F;
                 SSDVAL3 = CA[display[2]];
      }
      else if((value >= 100.0) && (value < 1000.0)){             //required if range of measurement is changed to 0 to 999 
                 dummy = (long)value;
                 splitnum();
                 SSDVAL1 = CA[display[0]];
                 SSDVAL2 = CA[display[1]];
                 SSDVAL3 = CA[display[2]];
      } 
      
      
      //Uncomment this code if you don't want to use interrupt to display SSD data.
      //If the below code is uncommented then ISR code has to be commented out.
      /*
      turnoffssd();
      output_c(SSDVAL3);
      output_high(PIN_b0);
      delay_ms(2);
      
      turnoffssd();
      output_c(SSDVAL2);
      output_high(PIN_b1);
      delay_ms(2);
      
      turnoffssd(); 
      output_c(SSDVAL1);
      output_high(PIN_b2);
      delay_ms(2);
      */
      
   }
 
}
